searchNodes=[{"doc":"Paraxial.io functions for use by users.","ref":"Paraxial.html","title":"Paraxial","type":"module"},{"doc":"","ref":"Paraxial.html#bulk_allowed?/3","title":"Paraxial.bulk_allowed?/3","type":"function"},{"doc":"","ref":"Paraxial.html#email_trusted?/2","title":"Paraxial.email_trusted?/2","type":"function"},{"doc":"This plug evaluates if an incoming conn should be allowed or blocked. It should be placed in the endpoint.ex file of a Phoenix application, before the Recorder plug.","ref":"Paraxial.AllowedPlug.html","title":"Paraxial.AllowedPlug","type":"module"},{"doc":"","ref":"Paraxial.AllowedPlug.html#call/2","title":"Paraxial.AllowedPlug.call/2","type":"function"},{"doc":"","ref":"Paraxial.AllowedPlug.html#init/1","title":"Paraxial.AllowedPlug.init/1","type":"function"},{"doc":"This plug is used to add metadata to the conn assigns if an IP matches a cloud provider.","ref":"Paraxial.AssignCloudIP.html","title":"Paraxial.AssignCloudIP","type":"module"},{"doc":"","ref":"Paraxial.AssignCloudIP.html#call/2","title":"Paraxial.AssignCloudIP.call/2","type":"function"},{"doc":"","ref":"Paraxial.AssignCloudIP.html#init/1","title":"Paraxial.AssignCloudIP.init/1","type":"function"},{"doc":"Plug used to block cloud provider IPs.","ref":"Paraxial.BlockCloudIP.html","title":"Paraxial.BlockCloudIP","type":"module"},{"doc":"","ref":"Paraxial.BlockCloudIP.html#call/2","title":"Paraxial.BlockCloudIP.call/2","type":"function"},{"doc":"","ref":"Paraxial.BlockCloudIP.html#init/1","title":"Paraxial.BlockCloudIP.init/1","type":"function"},{"doc":"If a user's email is stored in conn.assigns.current_user.email , you can use this plug to do: assign(conn, :paraxial_current_user, conn.assigns.current_user.email)","ref":"Paraxial.CurrentUserPlug.html","title":"Paraxial.CurrentUserPlug","type":"module"},{"doc":"","ref":"Paraxial.CurrentUserPlug.html#call/2","title":"Paraxial.CurrentUserPlug.call/2","type":"function"},{"doc":"","ref":"Paraxial.CurrentUserPlug.html#init/1","title":"Paraxial.CurrentUserPlug.init/1","type":"function"},{"doc":"Used to record metadata about requests for processing by Paraxial.io backend.","ref":"Paraxial.RecordPlug.html","title":"Paraxial.RecordPlug","type":"module"},{"doc":"","ref":"Paraxial.RecordPlug.html#call/2","title":"Paraxial.RecordPlug.call/2","type":"function"},{"doc":"","ref":"Paraxial.RecordPlug.html#init/1","title":"Paraxial.RecordPlug.init/1","type":"function"},{"doc":"","ref":"readme.html","title":"Paraxial.io Agent Guide","type":"extras"},{"doc":"Welcome to the Paraxial.io agent documentation. The page will introduce you to key features of the agent, how to install it in your project, and how to use conn assigns for sending select user data to the backend. Index Agent Features Detailed Installation Instructions Debugging Installation Errors Paraxial Functions Paraxial Plugs Assigns Additional Documentation If you are already familiar with the Paraxial.io agent, and are looking for a concise set of steps to install the agent, without exposition, see the install page.","ref":"readme.html#introduction","title":"Paraxial.io Agent Guide - Introduction","type":"extras"},{"doc":"Allowing and Blocking Requests When an request arrives in an application protected by Paraxial.io, the agent determines if the request's conn should be allowed or blocked. A request may be blocked for many reasons, such as matching a user-defined rule, belonging to a cloud provider's IP range, or being placed on a site's ban list by a user. An example of a user defined rule is, &quot;If one IP address sends &gt; 10 login requests in 5 seconds, ban it&quot;. The decision to allow or deny a request is based on the value of conn.remote_ip . If you are hosting your Phoenix application behind a proxy, this value is probably different from the real IP of the client. To fix this, use the remote_ip library. Cloud IP Range Matching The agent is able to determine if an incoming request's IP address matches the IP range of several major cloud providers. For more details, see cloud ip matching. Trusted Domains and Bulk Actions If the Paraxial.io customer application contains code for a bulk action, such as a user sending dozens of emails with a single POST request, the agent can maintain a data structure of &quot;trusted&quot; domains. Users from these trusted domains can be granted a higher threshold for the bulk action, compared with users from untrusted domains. This means mike@paraxial.io can send up to 100 emails at a time, while kyle@10minmail.com will be limited to 3. Data Forwarding to Paraxial.io Backend The agent forwards data about incoming requests to the Paraxial.io backend. These are several paraxial_ prefixed assigns available, to add information about the customer application's users to this data. For example, if you want to quickly determine which requests are associated with logged-in users, use the :paraxial_current_user assigns.","ref":"readme.html#1-agent-features","title":"Paraxial.io Agent Guide - 1. Agent Features","type":"extras"},{"doc":"(Optional) Install remote_ip in your application If your application is showing a different conn.remote_ip than expected, it is probably behind a proxy. Install the remote_ip library to fix this. Use plug Plug.RequestId in your application's endpoint.ex file: The majority of Phoenix applications do this by default. Check your endpoint.ex file for the line: plug Plug.RequestId This plug sets x-request-id , which is required for the Paraxial agent to work correctly. If it does not exist, add it to your project. Install :paraxial in your application's mix.exs file: def deps do [ { :paraxial , &quot;~&gt; 0.0.3&quot; } ] end Application Configuration: In your Paraxial.io account, we recommend creating two different sites for your application. One site for development/testing, and one site for production. For your local environment, edit your application's config/dev.exs : config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true , bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) Configuration keys and values: paraxial_api_key - Found in your site's settings page. Required for secure communication between the agent and Paraxial.io backend service. paraxial_url - This is https://app.paraxial.io . fetch_cloud_ips - By default, Paraxial.io will sent HTTP requests to retrieve the public IP ranges of several cloud providers. If you wish to disable this, set fetch_cloud_ips to false . When disabled, matching incoming requests against cloud IP addresses will not work. bulk and trusted_domains - In the above example, user emails ending in @paraxial.io or @blackcatprojects.xyz will be able to send up to 100 emails. Emails from different domains can only send 3. These values are optional. Configure Plugs Open endpoint.ex and add the required plugs: plug RemoteIp plug Paraxial.AllowedPlug plug Paraxial.RecordPlug plug HavanaWeb.Router plug Paraxial.RecordPlug The duplicated Paraxial.RecordPlug before and after the router is intentional, it is done to record requests that fail to match in the router. Optional Plugs (Place Before Allowed Plug) Paraxial.CurrentUserPlug Paraxial.AssignCloudIP Paraxial.BlockCloudIP See the section below for details about these plugs.","ref":"readme.html#2-detailed-installation-instructions","title":"Paraxial.io Agent Guide - 2. Detailed Installation Instructions","type":"extras"},{"doc":"Check that your application is configured correctly. 1. Set your application's local logging level to debug. This will allow you to see debug messages from the Paraxial agent. Example config/dev.exs : config :logger , level : :debug 2. Check the Paraxial lines in config/dev.exs are similar to: config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true , bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) The following values are optional: fetch_cloud_ips bulk trusted_domains 3. Start your application locally, read the debug lines from Paraxial. Bad start: @ house % mix phx . server [ warning ] Paraxial API key not found . This warning means your application is not configured correctly. Check your config files. Bad start: [ error ] Task # PID &lt; 0 . 764 . 0 &gt; started from Paraxial.Crow terminating ** (Protocol.UndefinedError) protocol Enumerable not implemented for nil of type Atom. Thi This warning means you have an api_key and url defined, but at least one of them is incorrect. Check both. Good start: @ house % mix phx . server [ debug ] [ Paraxial ] :fetch_cloud_ips set to true , fetching ... [ debug ] [ Paraxial ] Prefixes downloaded for aws : 7981 [ debug ] [ Paraxial ] Prefixes downloaded for azure : 59042 [ debug ] [ Paraxial ] Prefixes downloaded for digital_ocean : 1640 [ debug ] [ Paraxial ] Prefixes downloaded for gcp : 531 [ debug ] [ Paraxial ] Prefixes downloaded for oracle : 490 [ debug ] [ Paraxial ] Prefixes length with duplicates : 69684 [ debug ] [ Paraxial ] Iptrie count - 41834 [ debug ] [ Paraxial ] Iptrie size in MB : 1.299092 [ debug ] [ Paraxial ] Agent start success [ info ] Running HouseWeb.Endpoint with cowboy 2.9 . 0 at 127.0 . 0.1 : 4002 ( http ) [ info ] Access HouseWeb.Endpoint at http :// localhost : 4002 [ watch ] build finished , watching for changes ...","ref":"readme.html#3-debugging-installation-errors","title":"Paraxial.io Agent Guide - 3. Debugging Installation Errors","type":"extras"},{"doc":"Paraxial.bulk_allowed?(email, bulk_action, count) Input: An application user's email address, the name of a bulk action, and the count for the action. Return value: True if the user is allowed to perform the action, false otherwise. Example config: config :paraxial , # ... bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) &gt; Paraxial . bulk_allowed? ( &quot;mike@blackcatprojects.xyz&quot; , :email , 3 ) &gt; true &gt; Paraxial . bulk_allowed? ( &quot;mike@blackcatprojects.xyz&quot; , :email , 100 ) &gt; true &gt; Paraxial . bulk_allowed? ( &quot;mike@test.xyz&quot; , :email , 4 ) &gt; false","ref":"readme.html#4-paraxial-functions","title":"Paraxial.io Agent Guide - 4. Paraxial Functions","type":"extras"},{"doc":"The Paraxial.io Agent provides several Plugs to be used in your application code: Paraxial.AllowedPlug - Required, this Plug determines if an incoming requests matches your allow/block lists. If a request is halted by this Plug, internally Paraxial will still record it. Paraxial.RecordPlug - Required, records incoming HTTP requests into a local buffer, then sends them to the Paraxial.io backend. Paraxial.AssignCloudIP - Optional, if the remote_ip of an incoming request matching a cloud provider IP address, this plug will add metadata to the conn via an assigns. For example, if a conn's remote_ip matches aws, this plug will do assigns(conn, :paraxial_cloud_ip, :aws) . Paraxial.BlockCloudIP - Optional, similar to AssignCloudIP. When a conn matches a cloud provider IP, the assign is updated and the conn is halted, with a 404 response sent to the client. Paraxial.CurrentUserPlug - Optional, only works if conn.assigns.current_user.email is set. Sets the :paraxial_current_user assigns by calling assign(conn, :paraxial_current_user, conn.assigns.current_user.email)","ref":"readme.html#5-paraxial-plugs","title":"Paraxial.io Agent Guide - 5. Paraxial Plugs","type":"extras"},{"doc":"This is a table of every Paraxial assigns value. To avoid conflict with assigns in your application code, each assigns key is prefixed with paraxial . Key Set By Type :paraxial_login_success User Application Boolean :paraxial_login_user_name User Application String :paraxial_current_user User Application String :paraxial_cloud_ip Paraxial Agent String (aws, azure, etc.) To monitor login attempts, use: assign ( conn , :paraxial_login_success , true / false ) To monitor the login name for the given login attempt use: assign ( conn , :paraxial_login_user_name , &quot;userNameHere&quot; ) To map incoming requests to the currently logged in user, use: assign ( conn , :paraxial_current_user , &quot;userNameHere&quot; ) The :paraxial_cloud_ip assign is set by Paraxial.AssignCloudIP . If you do not use this assign anywhere in your application code, and just want to block cloud IPs, use Paraxial.BlockCloudIP . Check your configuration to ensure fetch_cloud_ips: true is set.","ref":"readme.html#6-assigns","title":"Paraxial.io Agent Guide - 6. Assigns","type":"extras"},{"doc":"Agent Internals Cloud IPs Brief Install Guide","ref":"readme.html#7-additional-documentation","title":"Paraxial.io Agent Guide - 7. Additional Documentation","type":"extras"},{"doc":"","ref":"agent.html","title":"Agent Internals","type":"extras"},{"doc":"The main tasks of the Paraxial.io agent are: Record incoming HTTP requests and send them to the Paraxial.io backend for processing Enforce bans against IP addresses Enforce rules with a time period of &lt; 30 seconds, using local ETS tables for state","ref":"agent.html#introduction","title":"Agent Internals - Introduction","type":"extras"},{"doc":"Sent to backend: Bundles of HTTP requests, Paraxial.HTTPBuffer.send_http(state), Retrieved from backend for local use: Local rules in Paraxial.Crow Bans from backend in Paraxial.Crow Important values: How often are HTTP request bundles sent to backend? (3 seconds) Max length of local rules (30 seconds) Local bans cleared (60 seconds) Crow: Every 3 seconds, update_local_rules() and update_backend_bans() Every 60 seconds, clear local bans HTTPBuffer: Every 3 seconds, send http bundle and clear local state. Paraxial.io backend: @local_rule_max_seconds 30 only rules with a time period &lt; @local_rule_max_seconds are sent to agent","ref":"agent.html#information-sent-received-by-agent","title":"Agent Internals - Information Sent/Received by Agent","type":"extras"},{"doc":"AllowedPlug -&gt; Paraxial.Crow.eval_http(conn) RecordPlug -&gt; Paraxial.HTTPBuffer.add_http_event(conn)","ref":"agent.html#plug-module-function-map","title":"Agent Internals - Plug -&gt; Module -&gt; Function Map","type":"extras"},{"doc":"Crow: :backend_bans :local_bans :rule_names LocalRule: :local_rule_n ets_atom is used for table name ets atom is :&quot;local_rule \#{rule.id}&quot;","ref":"agent.html#ets-tables","title":"Agent Internals - ETS Tables","type":"extras"},{"doc":"By default, several Cloud hosting IP ranges are defined in the Paraxial agent: AWS Azure GCP Digital Ocean Oracle For each cloud provider, the following are defined: Cloud provider name IP prefixes URL Response to Iptrie function At some point in the future is may be possible for customers to define a custom data source. The configuration of data center IP fetching is done in the customer app config file: config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_data_center_ips : true The default value of fetch_data_center_ips is true.","ref":"cloud_ips.html","title":"Cloud IP Matching","type":"extras"},{"doc":"On agent start, get all the IP prefixes, put into Iptrie with cloud provider as value, then :persistent term.put({ _MODULE , :dc_ips}, ip_trie).","ref":"cloud_ips.html#paraxial-agent-start-and-persistent-term","title":"Cloud IP Matching - Paraxial Agent Start and Persistent Term","type":"extras"},{"doc":"","ref":"install.html","title":"Agent Quick Install","type":"extras"},{"doc":"This is a concise list of steps to install the Paraxial.io agent. It is intended for users who have already read the agent guide.","ref":"install.html#introduction","title":"Agent Quick Install - Introduction","type":"extras"},{"doc":"1. Mix install { :paraxial , &quot;~&gt; 0.0.3&quot; } 2. Config config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true , bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) 3. Edit endpoint.ex plug RemoteIp plug Paraxial.BlockCloudIP # Optional, will block all traffic from cloud IPs plug Paraxial.AllowedPlug plug Paraxial.RecordPlug plug HavanaWeb.Router plug Paraxial.RecordPlug 4. (Optional) To send current user, edit router.ex , add Paraxial.CurrentUserPlug defmodule HavanaWeb.Router do ... pipeline :browser do ... plug Paraxial.CurrentUserPlug end 5. (Optional) Send :paraxial_login_user_name via assigns In your application code, determine how a user's login attempt flows through the code. You are looking for the line right before the user's provided email and password are checked against the database. Once you find that location, re-write the conn with: conn = assign(conn, :paraxial_login_user_name, email) Where email is the user provided string for a login attempt. 6. (Optional) Send login success true or false conn = assign(conn, :paraxial_login_success, false) 7. (Optional) Use the Paraxial.bulk_allowed?/3 function In your Paraxial.io config, you can define :bulk and :trusted_domains bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) In your application code, Paraxial.bulk_allowed?(user.email, :email, length(list_of_emails)) will return true or false, depending on the value of the third argument (an integer), and if the email matching a trusted domain.","ref":"install.html#steps","title":"Agent Quick Install - Steps","type":"extras"}]